/*
Mode serveur
Attente d'une requete GET /?ETAT=LED1 ou /?ETAT=LED0 pour allumer 1 ou eteindre
la LED

La requete GET est envoy depuis une page html hberge sur un servuer web
*/

/*
La procedure a suivre pour crer un serveur web avec envoi d'une donne :

Configuration de l'esp8266 : 
il faut que l'esp soit en mode AT+STA et connaitre l'adresse IP (IPscan32) ou utilisation du soft
ESPconfig.exe pour le placer dans le bon mode.

envoyer les commandes AT pour configurer le module ESP

A. Construire un Web server
1. Accepter les connections multiples : 
   envoyer "AT+CIPMUX=1\r\n"
2. Configurer en mode server  l'adresse 80  (80 car http sur port80)
   envoyer "AT+CIPSERVER=1,80\r\n"
3. Avec un navigateur web aller  l'adresse IP du module Wifi port80
   192.168.0.13:80 (chez moi)

4. Rception dune GET du module avec +IPD,0 ... avec 0 comme canal

5. Envoyer une rponse avec le canal et la taille des donnes en octet
   envoyer "AT+CIPSEND=channel,nboctet

Attention : finir l'envoi du html avec printf("\r\n\r\n"); le nb d'octet ne tient pas compte
de ce final.


6. Il faut fermer la connection 
*/

#include <16F876A.h>

#device adc=8



#FUSES NOWDT                    //No Watch Dog Timer
#FUSES HS                       //High speed Osc (> 4mhz for PCM/PCH) (>10mhz for PCD)
#FUSES NOPUT                    //No Power Up Timer
#FUSES NOPROTECT                //Code not protected from reading
#FUSES NOBROWNOUT               //No brownout reset
#FUSES NOLVP                    //No low voltage prgming, B3(PIC16) or B5(PIC18) used for I/O
#FUSES NOCPD                    //No EE protection
#FUSES NOWRT                    //Program memory not write protected
#FUSES NODEBUG                  //No Debug mode for ICD

#use delay(clock=20000000)
#use rs232(baud=9600,parity=N,xmit=PIN_C6,rcv=PIN_C7,bits=8,ERRORS)
#use rs232(baud=9600,parity=N,xmit=PIN_C5,rcv=PIN_C0,bits=8,stream=DEBUG,ERRORS)
#use i2c(Master,Fast,sda=PIN_C4,scl=PIN_C3)

#include <PCF2119_Driver_LCDI2C.c>
#include <stdlib.h>

#define allume_LEDVERTE output_high(PIN_C2);

#define  KEYHIT_DELAY   500     // in milliseconds
#define LEDROUGE PIN_C0 
#define LEDJAUNE PIN_C1
#define LEDVERTE PIN_C2

const int8 TailleBufferIn=30;

char DataBuffer[TailleBufferIn] ; //buffer d'entree
char HTML[30];
int8 valcan0;//valeur acquise sur canal0
int16 nboctet = 549;//attention nbctet doit etre exacte et inferieur  1024
boolean LEDROUGEON=true;//indicateur de LEDROUGE  ON ou off

#int_RDA
void  RDA_isr(void) 
{
int8 li;
int8 lchar;

//   disable_interrupts(GLOBAL); // all interrupts OFF
//   disable_interrupts(INT_RDA); // RS232 OF

 
//   enable_interrupts(GLOBAL); // all interrupts OFF
//   enable_interrupts(INT_RDA); // RS232 OFF

}

/*****************************************************************************/
boolean testOK(){

int8 i;
//attente OK
  while(getc()!='O') {};
  while(getc()!='K'){return(true);};
   
//fin attente OK

}//fin testOK
/*****************************************************************************/
/***************************************/
// initialisation du CAN
void initCAN(){
// initialise le CAN//
   setup_port_a( RA0_RA1_RA3_ANALOG );
   setup_adc( ADC_CLOCK_DIV_32 );
}

/***************************************/
// fonction d'acquisition : la valeur retourne est la valeur convertie du canal0
int8 acquerirCAN(int lcanal){

   int lvaquire;

   set_adc_channel( lcanal );
   delay_us(100);
   lvaquire=read_adc();
   return lvaquire;
}
/***************************************/



int8 recupCanal(){
/*
dtermine le canal  partir de la requete reu du navigateur
la requete est +IPD,0,307:GET / HTTP/1.1\0D    
*/

int8 lnumcanal;

   while(getc()!='+'){};
   while(getc()!='I'){};
   while(getc()!='P'){};
   while(getc()!='D'){};
   while(getc()!=','){};lnumcanal = atoi(getc());
   return(lnumcanal);

}//fin recupCanal


/*****************************************************************************/
void main()
{
int8 i=0;
int8 channel=0;
char strbuffer[20];
int8 lchar;
int8 valCAN;

   setup_adc_ports(AN0_AN1_AN3);
   setup_adc(ADC_CLOCK_INTERNAL);
   setup_timer_0(RTCC_INTERNAL|RTCC_DIV_1);
   setup_timer_1(T1_DISABLED);
   setup_timer_2(T2_DISABLED,0,1);

   set_tris_a(0b00111111);
   set_tris_b(0b11111111);
   set_tris_c(0b10010000);
   
   initCAN();//initialise le CAN
  
   
   Init_Ecran();//initialise l'cran LCD
   Efface_Ecran();
   allume_LEDVERTE;

    printf(Affiche_caractere,"WIFI SERVEUR\n\r");   
    delay_ms(2000);
//envoi command AT vers Wifi
   fputs("AT+RST"); //testOK() ; //reset le module ESP8266
   fprintf(DEBUG,"DEBUG ATRST\r\n");   delay_ms(1000);
//lecture de l'adresse IP du module ESP8266   
   fputs("AT+CIFSR");
   for(i=0;i<20;i++) 
   {
      DataBuffer[i]=getc(); //detecte l'arrivee d'un K de OK pour finir l'enregistrement des donnes
      if (DataBuffer[i] == 'K') break;
   }//for   
   Efface_Ecran();printf(Affiche_caractere,"%s ",DataBuffer);
   
do{  

   delay_ms(1000);
   fputs("AT+CIPMUX=1");  testOK(); delay_ms(1000);  //configure en multi connexion 
   Efface_Ecran();printf(Affiche_caractere,"CIPMUX=OK"); delay_ms(1000);


   fputs("AT+CIPSERVER=1,80");  testOK(); delay_ms(1000);//active (1) le module en mode server sur port 80
   Efface_Ecran();printf(Affiche_caractere,"Attente reqHTTP"); 

//attente du GET /?LED1 ou /?LED0 en provenance d'un client
   while(getc()!='L') {};
   while(getc()!='E') {};
   while(getc()!='D') {};

   if(getc()=='1') //ok test 
   {
      output_high(LEDROUGE);
      LEDROUGEON=true;
   }//if 
   else //sinon RDIOLR=0 alors eteindre ledrouge et memoriser l'info
   {
      output_low(LEDROUGE);
      LEDROUGEON=false;
      
   }//else
   Efface_Ecran();printf(Affiche_caractere,"GET RECU"); delay_ms(10000);
   puts("AT+CIPCLOSE=0"); // delay_ms(1000); //fermeture de la connection 
   
}while(1);
}//main
